import {AfterViewChecked, Component, ElementRef, OnInit, ViewChild} from '@angular/core';
import {TopologyService} from '../topology.service';
import {NzMessageService} from 'ng-zorro-antd';
import {DomSanitizer} from '@angular/platform-browser';
import * as $ from 'jquery';
declare let editor:any;
declare let layui:any;

@Component({
    selector: 'smart-ne-topology',
    templateUrl: './ne-topology.component.html',
    styles: [
        `
        .layui-side-scroll{
            width: initial;
        }
            .layui-layout-right{
                color: #666666;
            }
            .layui-layout-right span{
                margin-right: 15px;
                cursor: pointer;
            }
        `
    ]
})
export class NeTopologyComponent implements OnInit {
@ViewChild('topologyCanvas') topologyCanvas:ElementRef;

    dataSet;
    isVisible = false;
    image;
    topoId;

    constructor(private topologySer: TopologyService, private message: NzMessageService,
                private sanitizer:DomSanitizer) {
    }

    ngOnInit() {
        layui.use('element', ()=>{
            let element = layui.element;
        });
        this.loadCanvas();
        this.getList();
    }

    loadCanvas(){
        // 选择连线方式后的css样式
        $("#link-line").click( ()=> {
            $(this).css("background-color", "darkgray");
            $("#link-foldline-h").css("background-color", "white");
            $("#link-foldline-v").css("background-color", "white");
            $("#link-flexline-h").css("background-color", "white");
            $("#link-flexline-v").css("background-color", "white");
            $("#link-curveline").css("background-color", "white");
        });
        $("#link-foldline-h").click(()=> {
            $(this).css("background-color", "darkgray");
            $("#link-line").css("background-color", "white");
            $("#link-foldline-v").css("background-color", "white");
            $("#link-flexline-h").css("background-color", "white");
            $("#link-flexline-v").css("background-color", "white");
            $("#link-curveline").css("background-color", "white");
        });
        $("#link-foldline-v").click(()=> {
            $(this).css("background-color", "darkgray");
            $("#link-line").css("background-color", "white");
            $("#link-foldline-h").css("background-color", "white");
            $("#link-flexline-h").css("background-color", "white");
            $("#link-flexline-v").css("background-color", "white");
            $("#link-curveline").css("background-color", "white");
        });
        $("#link-flexline-h").click(()=> {
            $(this).css("background-color", "darkgray");
            $("#link-line").css("background-color", "white");
            $("#link-foldline-h").css("background-color", "white");
            $("#link-foldline-v").css("background-color", "white");
            $("#link-flexline-v").css("background-color", "white");
            $("#link-curveline").css("background-color", "white");
        });
        $("#link-flexline-v").click(()=> {
            $(this).css("background-color", "darkgray");
            $("#link-line").css("background-color", "white");
            $("#link-foldline-h").css("background-color", "white");
            $("#link-foldline-v").css("background-color", "white");
            $("#link-flexline-h").css("background-color", "white");
            $("#link-curveline").css("background-color", "white");
        });
        $("#link-curveline").click(()=> {
            $(this).css("background-color", "darkgray");
            $("#link-line").css("background-color", "white");
            $("#link-foldline-h").css("background-color", "white");
            $("#link-foldline-v").css("background-color", "white");
            $("#link-flexline-h").css("background-color", "white");
            $("#link-flexline-v").css("background-color", "white");
        });

        // 节点树中每个节点的拖放动作定义给拓扑图编辑器
        let nodes = $("[topo-div-type='topo-node']");
        let nodeLength = nodes.length;
        console.log(nodes);
        for (let i = 0; i < nodeLength; i++) {
            let text = $(nodes[i]).find("span").eq(0).text();
            editor.drag(nodes[i], document.getElementById('topology-canvas'), text);
        }
        editor.loadTopology( '', "img/backimg1.png");

    }

    //获取列表
    getList() {
        this.topologySer.findAll({}).subscribe(
            (res) => {
                if (res.errCode == 10000) {
                    this.dataSet = res.data;
                } else {
                    this.message.info(res.errMsg);
                }
            }
        );
    }

    //创建
    create(){
       let data = editor.saveTopology();
       console.log(data);
       this.topologySer.create(data).subscribe(
           (res)=>{

           }
       )
    }

    //查询单个
    getDetail(id){
        this.topologySer.findItem(id).subscribe(
            (res)=>{

            }
        )
    }


    handleOk() {
        this.isVisible = false;
        this.image = null;
    }
}
